"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RegisterSubCommandGroup = exports.RegisterSubCommand = void 0;
const decorators_1 = require("@sapphire/decorators");
const framework_1 = require("@sapphire/framework");
const builders_1 = require("@discordjs/builders");
const functions_1 = require("./functions");
const RegisterSubCommand = (parentCommandName, slashSubcommand) => {
    return (0, decorators_1.createClassDecorator)((target) => (0, decorators_1.createProxy)(target, {
        construct: (ctor, [context, baseOptions]) => {
            const slashSubcommandParsed = typeof slashSubcommand === 'function' ? slashSubcommand(new builders_1.SlashCommandSubcommandBuilder(), framework_1.container) : slashSubcommand;
            const ctr = new ctor(context, {
                ...baseOptions,
                name: framework_1.container.client.options.subcommandsAdvanced?.nameCommandsAutogenerated === true
                    ? `${parentCommandName}/${slashSubcommandParsed.name}`
                    : baseOptions.name
            });
            return (0, functions_1.analizeSubCommandParsed)(ctr, parentCommandName, slashSubcommandParsed);
        }
    }));
};
exports.RegisterSubCommand = RegisterSubCommand;
const RegisterSubCommandGroup = (parentCommandName, groupName, slashSubcommand) => {
    return (0, decorators_1.createClassDecorator)((target) => (0, decorators_1.createProxy)(target, {
        construct: (ctor, [context, baseOptions]) => {
            const slashSubcommandParsed = typeof slashSubcommand === 'function' ? slashSubcommand(new builders_1.SlashCommandSubcommandBuilder(), framework_1.container) : slashSubcommand;
            const ctr = new ctor(context, {
                ...baseOptions,
                name: framework_1.container.client.options.subcommandsAdvanced?.nameCommandsAutogenerated === true
                    ? `${parentCommandName}/${groupName}/${slashSubcommandParsed.name}`
                    : baseOptions.name
            });
            return (0, functions_1.analizeSubcommandGroupParsed)(ctr, parentCommandName, groupName, slashSubcommandParsed);
        }
    }));
};
exports.RegisterSubCommandGroup = RegisterSubCommandGroup;
//# sourceMappingURL=decorators.js.map